# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ur_dashboard_msgs/SetModeGoal.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ur_dashboard_msgs.msg

class SetModeGoal(genpy.Message):
  _md5sum = "a32b63f0e8a660b2b96916617d699c39"
  _type = "ur_dashboard_msgs/SetModeGoal"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# This action is for setting the robot into a desired mode (e.g. RUNNING) and safety mode into a
# non-critical state (e.g. NORMAL or REDUCED), for example after a safety incident happened.

# goal
ur_dashboard_msgs/RobotMode target_robot_mode

# Stop program execution before restoring the target mode. Can be used together with 'play_program'.
bool stop_program

# Play the currently loaded program after target mode is reached.#
# NOTE: Requesting mode RUNNING in combination with this will make the robot continue the motion it
# was doing before. This might probably lead into the same problem (protective stop, EM-Stop due to
# faulty motion, etc.) If you want to be safe, set the 'stop_program' flag below and manually play
# the program after robot state is returned to normal.
# This flag will only be used when requesting mode RUNNING
bool play_program


================================================================================
MSG: ur_dashboard_msgs/RobotMode
int8 NO_CONTROLLER=-1
int8 DISCONNECTED=0
int8 CONFIRM_SAFETY=1
int8 BOOTING=2
int8 POWER_OFF=3
int8 POWER_ON=4
int8 IDLE=5
int8 BACKDRIVE=6
int8 RUNNING=7
int8 UPDATING_FIRMWARE=8

int8 mode

"""
  __slots__ = ['target_robot_mode','stop_program','play_program']
  _slot_types = ['ur_dashboard_msgs/RobotMode','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       target_robot_mode,stop_program,play_program

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SetModeGoal, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.target_robot_mode is None:
        self.target_robot_mode = ur_dashboard_msgs.msg.RobotMode()
      if self.stop_program is None:
        self.stop_program = False
      if self.play_program is None:
        self.play_program = False
    else:
      self.target_robot_mode = ur_dashboard_msgs.msg.RobotMode()
      self.stop_program = False
      self.play_program = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_b2B().pack(_x.target_robot_mode.mode, _x.stop_program, _x.play_program))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.target_robot_mode is None:
        self.target_robot_mode = ur_dashboard_msgs.msg.RobotMode()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.target_robot_mode.mode, _x.stop_program, _x.play_program,) = _get_struct_b2B().unpack(str[start:end])
      self.stop_program = bool(self.stop_program)
      self.play_program = bool(self.play_program)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_b2B().pack(_x.target_robot_mode.mode, _x.stop_program, _x.play_program))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.target_robot_mode is None:
        self.target_robot_mode = ur_dashboard_msgs.msg.RobotMode()
      end = 0
      _x = self
      start = end
      end += 3
      (_x.target_robot_mode.mode, _x.stop_program, _x.play_program,) = _get_struct_b2B().unpack(str[start:end])
      self.stop_program = bool(self.stop_program)
      self.play_program = bool(self.play_program)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_b2B = None
def _get_struct_b2B():
    global _struct_b2B
    if _struct_b2B is None:
        _struct_b2B = struct.Struct("<b2B")
    return _struct_b2B
